<?php
/**
* @version 1.0
* @package JDownloads
* @copyright (C) 2011 www.jdownloads.com
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*
* Plugin to send every day a e-mail alert message before a download is unpublished.
* 
*/

defined( '_JEXEC' ) or die( 'Restricted access' );
Error_Reporting(E_ERROR);   

jimport('joomla.plugin.plugin'); 
  class plgSystemjdownloads_mail_alerter extends JPlugin { 
     
     function plgSystemjdownloads_mail_alerter (&$subject, $config) { 
        parent::__construct( $subject, $config ); 
     } 

     function onAfterInitialise() { 
     
         $app = &JFactory::getApplication();
         // No need in admin
         if( $app->isAdmin() ) return;
         
         $database = &JFactory::getDBO();
         $plugin =& JPluginHelper::getPlugin('system', 'jdownloads_mail_alerter');
         jimport( 'joomla.utilities.utility' );
         // get params
         $params = new JRegistry();
         $params->loadJSON($plugin->params);
         
         //$params = new JParameter( $plugin->params );
         $days        =    $params->get( 'sum_day_before_is_sended' );
         $mail        =    $params->get( 'emailadr' );
         $msg         =    $params->get( 'message' );
         
         // exit when values not set
         if (!$days || !$mail || !$msg) return; 
         
         // exists table?
         $prefix = $database->getPrefix();
         $tablelist = $database->getTableList();
         if ( !in_array ( $prefix.'jdownloads_mail_alerter', $tablelist ) ){
            $database->setQuery("CREATE TABLE IF NOT EXISTS `#__jdownloads_mail_alerter` (
                `id` int(11) NOT NULL auto_increment,
                `file_id` int(11) NOT NULL,
                `last_sended` date NOT NULL default '0000-00-00',
                PRIMARY KEY  (`id`)
                ) TYPE=MyISAM CHARACTER SET `utf8` COLLATE `utf8_general_ci`");
            $database->query();    
         }
         $j = date('Y');
         $m = date('m');
         $d = date('d');
         $unpublish_day = date('Y-m-d',mktime(0,0,0,$m,$d+$days,$j));
         $today = date('Y-m-d');

         // get all published single category menu links
         $database->setQuery("SELECT file_id, file_title, publish_to from #__jdownloads_files WHERE published = 1 AND use_timeframe = 1 AND publish_to <= '$unpublish_day'");
         $files = $database->loadObjectList();
         if ($files){
             foreach ($files as $file){
                // is e-mail today always sended?
                $database->setQuery("SELECT COUNT(*) from #__jdownloads_mail_alerter WHERE file_id = '$file->file_id' AND last_sended = '$today'");
                $sended = $database->loadResult();
                if (!$sended){
                    $html_format = true;
                    $config =& JFactory::getConfig();
                    $mailfrom = $config->getValue( 'mailfrom' );
                    $mailfromname = $config->getValue( 'fromname' );
                    $mail = str_replace(' ', '', $mail);
                    $recipient = explode(';', $mail);

                    $text = $msg;
                    $text = str_replace('{file_title}', $file->file_title, $text);
                    $text = str_replace('{file_id}', $file->file_id, $text);
                    $text = str_replace('{unpublished_date}', $file->publish_to, $text);
                    $success = JUtility::sendMail($mailfrom, $mailfromname, $recipient, 'Download alert', $text, $html_format, '');
                    if ($success){
                        $database->setQuery("INSERT INTO #__jdownloads_mail_alerter (file_id, last_sended) VALUES ('$file->file_id', '$today')");
                        $database->query();
                    }    
                }    
             }
         }
         $database->setQuery("DELETE FROM #__jdownloads_mail_alerter WHERE last_sended != '$today'");
         $database->query();     
         return;  
     }
  }  
?>